public class BoxHerencia {
    public static void main(String[] args){
        Envio envio1 = new Envio(15.2f);
        Envio envio2 = new Envio(5f, 6f, 10f, 15f);
        System.out.println("El envio uno tiene un volumen de : "+envio1.calcularVolumen()
                +"\nEl envio dos tiene un volumen de: "+envio2.calcularVolumen());
    }
}

class Caja{
    private float ancho;
    private float alto;
    private float profundidad;

    public Caja(Caja caja){
        this.ancho = caja.getAncho();
        this.alto = caja.getAlto();
        this.profundidad = caja.getProfundidad();
    }

    public Caja(float ancho, float alto, float profundidad) {
        this.ancho = ancho;
        this.alto = alto;
        this.profundidad = profundidad;
    }

    public Caja(){
        super();
    }

    public Caja(float lado){
        this.alto = lado;
        this.ancho = lado;
        this.profundidad = lado;
    }

    public float calcularVolumen(){
        return this.alto*this.ancho*this.alto;
    }

    public float getAncho() {
        return ancho;
    }

    public void setAncho(float ancho) {
        this.ancho = ancho;
    }

    public float getAlto() {
        return alto;
    }

    public void setAlto(float alto) {
        this.alto = alto;
    }

    public float getProfundidad() {
        return profundidad;
    }

    public void setProfundidad(float profundidad) {
        this.profundidad = profundidad;
    }
}

class CajaPeso extends Caja{
    private float peso;

    public CajaPeso(float ancho, float largo, float profundidad, float peso){
        super(ancho, largo, profundidad);
        this.peso = peso;
    }

    public CajaPeso(){
        super();
    }

    public float getPeso() {
        return peso;
    }

    public void setPeso(float peso) {
        this.peso = peso;
    }
}

class Envio extends CajaPeso{
    public Envio(){
        super();
    }

    public Envio(Envio envio){
        super();
        this.setAncho(envio.getAncho());
        this.setAlto(envio.getAlto());
        this.setProfundidad(envio.getProfundidad());
        this.setPeso(envio.getPeso());
    }

    public Envio(float lado){
        super();
        this.setAncho(lado);
        this.setProfundidad(lado);
        this.setAlto(lado);
    }

    public Envio(float ancho, float largo, float profundidad, float peso){
        super(ancho, largo, profundidad, peso);
    }


}